new;
library qam,optmum,pgraph;

cls;

case = 1;

PathName = "";

if case == 0;
  datFileName = PathName $+ "";
else;
  datFileName = PathName $+ "";
endif;
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = Fill_Miss(data,4);
if case /= 1;
  data = trimr(data,1,0);
endif;

Data = selif(Data,(Data[.,1] .>= 19991231) .and (Data[.,1] .<= 20091231));

Dates = Data[.,1];
nDates = rows(Dates);

SX5T = 100 * Data[.,3] ./ Data[1,3];
Libor_EUR = Data[.,5];
Eonia = Data[.,7];

Libor_Index = Compute_Capitalized_Eonia(Dates,Libor_EUR);
Eonia_Index = Compute_Capitalized_Eonia(Dates,Eonia);

Begin_Period = Dates[1];
End_Period = Dates[nDates];
nDays = etdays2(Dates[1],Dates[nDates]);
dt = nDays/365; 
dt = 10;

period = Dates[1]|Dates[nDates];

Backtest = SX5T;
print Data[nDates,3]~Data[1,3];

// Question 2

mu = (Backtest[nDates]./Backtest[1])^(1/dt) - 1; 
Rdt = Backtest ./ lag1(Backtest) - 1;
sigma = stdc(packr(Rdt)) * sqrt(260);            

print "--------- Question 2 ------------------------";
print ftosa(100*mu,"mu = %lf",3,2);
print ftosa(100*sigma,"sigma = %lf",3,2);

// Question 3.a

mu_R = meanc(Eonia); 
SR = (mu - mu_R)/sigma;

print "--------- Question 3.a ----------------------";
print ftosa(100*mu_R,"mu_R = %lf",3,2);
print ftosa(SR,"Sharpe = %lf",3,4);

// Question 3.b

R_index = Eonia_Index;
mu_R = (R_Index[nDates]./R_Index[1])^(1/dt) - 1; 
Surperf = mu - mu_R;
SR = (mu - mu_R)/sigma;

print "--------- Question 3.b ----------------------";
print ftosa(100*mu_R,"mu_R = %lf",3,2);
print ftosa(100*Surperf,"Surperf = %lf",3,2);
print ftosa(SR,"Sharpe = %lf",3,4);

Surperf = ((Backtest[nDates]/Backtest[1])/(R_Index[nDates]/R_Index[1]))^(1/dt) - 1; 
SR = Surperf/sigma;

print "--------- Question 3.b ----------------------";
print ftosa(100*Surperf,"Surperf = %lf",3,2);
print ftosa(SR,"Sharpe = %lf",3,4);

// Question 5


mu_R = meanc(Libor_EUR); 
SR = (mu - mu_R)/sigma;
print "--------- Question 5 ----------------------";
print ftosa(100*mu_R,"mu_R = %lf",3,2);
print ftosa(SR,"Sharpe = %lf",3,4);

R_index = Libor_Index;
mu_R = (R_Index[nDates]./R_Index[1])^(1/dt) - 1; 
SR = (mu - mu_R)/sigma;
print ftosa(100*mu_R,"mu_R = %lf",3,2);
print ftosa(SR,"Sharpe = %lf",3,4);

Surperf = ((Backtest[nDates]/Backtest[1])/(R_Index[nDates]/R_Index[1]))^(1/dt) - 1; 
SR = Surperf/sigma;
print ftosa(100*Surperf,"Surperf = %lf",3,2);
print ftosa(SR,"Sharpe = %lf",3,4);

graphset;
  begwind;
  window(2,2,0);

    _pdate = ""; _pnum = 2; _pframe = 0;
    _plwidth = 8; _pltype = 6|3; _pcolor = 1|4;
    _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.275;
    xtics(0,nDates,2*262,1);
    let xlab = "2000" "02" "04" "06" "08" "10";
    asclabel(xlab,0);

  ytics(0,5,1,2);

  setwind(1);
    _pcolor = 1;
    title("\216Eonia (en %)");
    xy(0,100*Eonia);

  setwind(2);
    _pcolor = 2;
    title("\216Euribor 1M (en %)");
    xy(0,100*Libor_EUR);

  ytics(100,140,10,2); _pgrid = {3,1};

  setwind(3);
    _pcolor = 3;
    title("\216Eonia capitalise");
    _pmsgstr = "-";
    _pmsgctl = 6.32~6.38~0.10~45~2~0~5;
    xy(0,Eonia_Index);

  setwind(4);
    _pcolor = 4;
    title("\216Euribor 1M capitalise");
    _pmsgstr = "-";
    _pmsgctl = 6.89~6.38~0.10~45~2~0~5;
    xy(0,Libor_Index);

  endwind;



