new;
library qam,pgraph,optmum;

cls;
__output = 0;

let mu =    0.15 0.10 0.08 0.06;
let sigma = 0.15 0.10 0.07 0.05;
let rho = 1.00 
          0.50 1.00
          0.20 0.20 1.00
          0.00 0.00 0.00 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);

A = ones(1,4); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(4,1);

// Question 1

Results = zeros(8,3);

phi = seqa(0,0.0001,10001);
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu,cov,A,B,C,D,Bounds,phi,0);

rf = 0.02;
sh = (er - rf)./risk;  
indx = maxindc(sh);
Results[.,1] = rf|x[.,indx]|er[indx]|risk[indx]|sh[indx];

rf = 0.03;
sh = (er - rf)./risk;  
indx = maxindc(sh);
Results[.,2] = rf|x[.,indx]|er[indx]|risk[indx]|sh[indx];

rf = 0.04;
sh = (er - rf)./risk;  
indx = maxindc(sh);
Results[.,3] = rf|x[.,indx]|er[indx]|risk[indx]|sh[indx];

print ftosa(100*Results,"%lf",3,2);
print "-----------------------------------------------";

phi = 0|0.25;
cov_star = (cov ~ zeros(4,1)) | zeros(1,5);
A_star = ones(1,5); B_star = 1; C_star = 0; D_star = 0; Bounds_star = (-10~10) .* ones(5,1);

rf = 0.02;
mu_star = mu | rf;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu_star,cov_star,A_star,B_star,C_star,D_star,Bounds_star,phi,0);
x1 = x[.,1]; x2 = x[.,2];
alpha = x1[5]/(x1[5] - x2[5]);
x = (1-alpha) * x1 + alpha * x2;
er = x'mu_star; risk = sqrt(x'*cov_star*x); sh = (er - rf)/risk;  
Results[.,1] = rf|trimr(x,0,1)|er|risk|sh;

rf = 0.03;
mu_star = mu | rf;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu_star,cov_star,A_star,B_star,C_star,D_star,Bounds_star,phi,0);
x1 = x[.,1]; x2 = x[.,2];
alpha = x1[5]/(x1[5] - x2[5]);
x = (1-alpha) * x1 + alpha * x2;
er = x'mu_star; risk = sqrt(x'*cov_star*x); sh = (er - rf)/risk;  
Results[.,2] = rf|trimr(x,0,1)|er|risk|sh;

x_opt_sh = trimr(x,0,1);

rf = 0.04;
mu_star = mu | rf;
{x,er,risk,phi,retcode} = Qprog_Allocation_Solve(mu_star,cov_star,A_star,B_star,C_star,D_star,Bounds_star,phi,0);
x1 = x[.,1]; x2 = x[.,2];
alpha = x1[5]/(x1[5] - x2[5]);
x = (1-alpha) * x1 + alpha * x2;
er = x'mu_star; risk = sqrt(x'*cov_star*x); sh = (er - rf)/risk;  
Results[.,3] = rf|trimr(x,0,1)|er|risk|sh;

print ftosa(100*Results,"%lf",3,2);
print "-----------------------------------------------";

// Question 2

Results = zeros(10,6);

rf = 0.03;
let x0 = 0.60 0.30 0.10 0.00;
er = x0'mu;
risk = sqrt(x0'cov*x0);
Sh = (er-rf)/risk;

Results[.,1] = x0|er|risk|sh|0|0|0;

{x,te,surperf} = Qprog_Index_Solve(x0,cov,A,B,C,D,Bounds,0,mu,0,x0);
IR = surperf/te;
er = x'mu; risk = sqrt(x'cov*x); Sh = (er-rf)/risk;
Results[.,2] = x|er|risk|sh|surperf|te|IR;

{x,te,surperf} = Qprog_Index_Solve(x0,cov,A,B,C,D,Bounds,100,mu,0,x0);
IR = surperf/te;
er = x'mu; risk = sqrt(x'cov*x); Sh = (er-rf)/risk;
Results[.,3] = x|er|risk|sh|surperf|te|IR;

{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,C,D,Bounds,mu,0.03);
IR = surperf/te;
er = x'mu; risk = sqrt(x'cov*x); Sh = (er-rf)/risk;
Results[.,4] = x|er|risk|sh|surperf|te|IR;

phi = seqa(0,0.001,1001);
{x,te,surperf} = Qprog_Index_Solve(x0,cov,A,B,C,D,Bounds,phi,mu,0,x0);
IR = surperf./te;
indx = maxindc(IR);
x = x[.,indx]; er = x'mu; risk = sqrt(x'cov*x); Sh = (er-rf)/risk;
Results[.,5] = x|er|risk|sh|surperf[indx]|te[indx]|IR[indx];

te = seqa(0.000,0.0001,50);
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,C,D,Bounds,mu,te);
IR = surperf./te;
indx = maxindc(IR);
x = x[.,indx]; er = x'mu; risk = sqrt(x'cov*x); Sh = (er-rf)/risk;
Results[.,6] = x|er|risk|sh|surperf[indx]|te[indx]|IR[indx];

print ftosa(100*Results,"%lf",3,2);
print "-----------------------------------------------";

Bounds = ones(4,1) .* (0.10~0.50);
{x_min,te_min,er_te} = Qprog_Index_Solve(x0,cov,A,B,C,D,Bounds,0,mu,0,x0);
{x_max,te_max,er_te} = Qprog_Index_Solve(x0,cov,A,B,C,D,Bounds,100,mu,0,x0);
print ftosa(100*(x_min~x_max),"%lf",3,2);
print ftosa(100*(te_min~te_max),"te = %lf",3,2);
print "-----------------------------------------------";

x = x_opt_sh;
surperf = (x-x0)'mu; 
te = sqrt((x-x0)'cov*(x-x0)); 
ir = surperf/te;
print ir;



/*

            2.00             3.00             4.00 
           10.73            13.24            17.43 
           12.06            12.34            12.80 
           28.92            29.23            29.73 
           48.29            45.20            40.04 
            8.03             8.27             8.68 
            4.27             4.45             4.84 
          141.29           118.30            96.65 
-----------------------------------------------

            2.00             3.00             4.00 
           10.72            13.25            17.43 
           12.06            12.34            12.80 
           28.92            29.23            29.73 
           48.30            45.19            40.04 
            8.03             8.27             8.68 
            4.26             4.45             4.84 
          141.29           118.30            96.65 
-----------------------------------------------

           60.00            60.00           100.00            83.01            60.33            60.07 
           30.00            30.00             0.00            16.99            29.92            29.98 
           10.00            10.00             0.00             0.00             9.75             9.95 
            0.00             0.00             0.00             0.00             0.00             0.00 
           12.80            12.80            15.00            14.15            12.82            12.80 
           10.99            10.99            15.00            13.38            11.03            11.00 
           89.15            89.15            80.00            83.32            89.04            89.12 
            0.00             0.00             2.20             1.35             0.02             0.00 
            0.00             0.00             5.16             3.00             0.05             0.01 
            0.00             0.00            42.62            45.01            46.54            46.54 
-----------------------------------------------

           50.00            50.00 
           30.00            30.00 
           10.00            10.00 
           10.00            10.00 
       te = 1.58        te = 1.58 
-----------------------------------------------

*/