new;
library qam,optmum,pgraph;

cls;

let mu    = 5.0 10.0  8.0 12.0 12.0;
let sigma = 5.0 15.0 15.0 20.0 30.0;

mu = mu/100;
sigma = sigma/100;
let cor =   1
            0.1     1.0
           -0.1     0.5     1.0
           -0.1     0.5     0.7     1.0
            0.0     0.2     0.2     0.4     1.0;
cor = xpnd(cor);
cov = cor .* sigma .* sigma';
call invpd(cov);

let x_Bench = 0.55 0.00 0.45 0.00 0.00;

rf = 0.02;

sh = 0.10; 
{Pi1,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);

sh = 0.25; 
{Pi2,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);

sh = 0.50; 
{Pi3,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);
print ftosa(100*(Pi1~Pi2~Pi3),"%lf",3,1);

sh = 0.25; rf = 0.00;
{Pi4,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);

sh = 0.25; rf = 0.04;
{Pi5,phi} = Black_Litterman_Pi(x_Bench,cov,sh,rf,0);

print ftosa(100*(Pi2~Pi1~Pi3~Pi4~Pi5),"%lf",3,1);

sh = 0.25; rf = 0.02;


mu_Target = 7.0/100;
nBasket = 5;
x0 = ones(nBasket,1)/nBasket;

Bounds = 0.0~1.0;

sh = 0.25; 
P = eye(nBasket); Q = mu; Omega = eye(nBasket) .* 0.05; Omega = Omega^2;

{x_BL1,phi,Pi_,mu_cond,TE} = Black_Litterman_Solve2(x_bench,cov,sh,rf,P,Q,Omega,Bounds,mu,mu_target,1e-10,0.5);

x = x_Bench~x_BL1;

print "-------------------------------";
print ftosa(100*x,"%lf",3,1);

ER_Bench = x_Bench'mu;
ER = x'mu;
VOL = sqrt(diag(x'*cov*x));
TE = sqrt(diag( (x-x_Bench)'*cov*(x-x_Bench) ));
IR = (ER - ER_Bench) ./ TE;

data = ER' | VOL' | TE' | IR';
print "-------------------------------";
print ftosa(100*data,"%lf",3,1);

/*

             0.6              0.8              1.2 
             3.0              4.2              6.1 
             5.3              7.4             10.8 
             4.9              6.8              9.9 
             2.2              3.1              4.5 
-------------------------------

            55.0             45.7 
             0.0              4.2 
            45.0             43.0 
             0.0              2.7 
             0.0              4.5 
-------------------------------

             6.3              7.0 
             7.0              7.7 
             0.0              1.9 
                             35.1 
*/