new;
library qam,pgraph,optmum;
dlibrary quad;

cls;

N_Vega = 50000;
volatility = 26|13;
K = 20;
PnL = VarianceSwap_Payoff(N_vega,volatility,K);
print ftosa(PnL,"%lf",3,2);

t = seqa(0,1,21);
Let St = 100 98   101   103   104   98   95   95   96   95   94 
         100   101   102   101   110   103   103   103   104   105;

n = rows(t) - 1;
Rt = ln(St ./ lag1(St));
Rt = trimr(Rt,1,0);
sigma = 100 * sqrt(252) * sqrt( sumc(Rt^2) / 20 );
print ftosa(sigma,"sigma = %lf",3,2);
PnL = VarianceSwap_Payoff(N_vega,sigma,K);
print ftosa(PnL,"PnL(0,20) = %lf",3,2);

PnL = N_vega/(2 * n * K) * cumsumc( 100^2 * 252 * Rt^2 - K^2 );
print ftosa(trimr(t,1,0)~PnL,"%lf",3,2);

print ftosa(PnL[5],"PnL(0,5) = %lf",3,2);

new_K = 24;
MtM = N_vega * 15 / 20 * (new_K^2 - K^2) / (2 * K);
print ftosa(MtM,"MtM(5,20) = %lf",3,2);
MtM = PnL[5] + MtM;
print ftosa(MtM,"MtM(5,20) = %lf",3,2);
MtM = PnL[5] + MtM;


new_K = 18;
MtM = N_vega * 15 / 20 * (new_K^2 - K^2) / (2 * K);
print ftosa(MtM,"MtM(5,20) = %lf",3,2);
MtM = PnL[5] + MtM;
print ftosa(MtM,"MtM(5,20) = %lf",3,2);
MtM = PnL[5] + MtM;

t = 20/262;
K = 20 * sqrt( (exp(10*t) - 1) ./ (10 * t));
print ftosa(K,"K = %lf",3,2);

S0 = 100;
r = 0;
tau = 20/262;
tau = 1;
F0 = S0 * exp(r * tau);
alpha = 0.01;
alpha = 0.4;

proc fn1(K);
  local sigma,P;
  sigma = 0.20 * (1 + alpha * (ln(K./S0)^2) );

  _Option_Type = "put";
  P = EuropeanBS(S0,K,sigma,tau,r,r);
  retp(P ./ (K^2) );
endp;

proc fn2(K);
  local sigma,C;
  sigma = 0.20 * (1 + alpha * (ln(K./S0)^2) );

  _Option_Type = "call";
  C = EuropeanBS(S0,K,sigma,tau,r,r);
  retp(C ./ (K^2) );
endp;

bounds = F0|1;
I1 = quadLegendre1(&fn1,bounds,256);

bounds = 500|F0;
I2 = quadLegendre1(&fn2,bounds,256);

I3 = r * Tau - ln(F0./S0) - (S0 .* exp(r *tau) ./ F0 - 1);
print ftosa(I1~I2~I3,"%lf",3,5);

K_var = 2 ./ tau * (I1 + I2 + I3);
K = 100*sqrt(K_var);
print ftosa(K_var,"%lf",3,5);
print ftosa(K,"%lf",3,5);
