new;
library qam,optmum,pgraph;

cls;

case = 0;

PathName = "";

if case == 1;
  datFileName = PathName $+ "data";
else;
  datFileName = PathName $+ "data";
endif;
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

data = Fill_Miss(data,4);
if case /= 1;
  data = trimr(data,1,0);
endif;

Dates = data[.,1]; nDates = rows(Dates);

SPTR = 100 * Data[.,2] ./ Data[1,2];
SX5T = 100 * Data[.,3] ./ Data[1,3];
SBEB = 100 * Data[.,4] ./ Data[1,4];

Libor_EUR = Data[.,5];
Libor_USD = Data[.,6];
Eonia = Data[.,7];

indx = 1|nDates;

SPTR_EUR = Currency_Hedging(Dates,SPTR,LIBOR_EUR,LIBOR_USD);

print "=====================  Question 1  =======================================";
print ftosa(Dates[indx]',"%lf",1,0);
print ftosa(SPTR[indx]',"%lf",1,2);
print ftosa(SPTR_EUR[indx]',"%lf",1,2);

Weights_Basket = ones(nDates,1) .* (0.25~0.25~0.50);
Basket = SPTR_EUR~SX5T~SBEB;

F1 = Compute_Monthly_Backtest(Dates,Weights_Basket,Basket);
F2 = F1;

dt = etdays2(lag1(dates),dates)/365;
mf = 0.01;

t = 2;
do until t > nDates;
  F2[t] = F2[t-1] * (F1[t]./F1[t-1] - mf .* dt[t]);
  t = t + 1;
endo;

print "=====================  Questions 2 & 3  =======================================";
print ftosa(Dates[indx]',"%lf",1,0);
print ftosa(F1[indx]',"%lf",1,2);
print ftosa(F2[indx]',"%lf",1,2);

NR_Index = Compute_Capitalized_Eonia(Dates,Libor_EUR);
Results = Compute_Global_Reporting(Dates,F2,NR_Index,NR_Index,0,0);

xlsFileName = "ex9-reporting.xlsx";
retcode = Excel_Reporting(Results,xlsFileName);

graphset;
  begwind;
  window(2,2,0);

    _pdate = ""; _pnum = 2; _pframe = 0;
    _plwidth = 8; _pltype = 6|3; _pcolor = 1|4;
    _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.275;
    xtics(0,nDates,2*262,1);
    let xlab = "2000" "02" "04" "06" "08" "10";
    asclabel(xlab,0);

  ytics(50,125,25,2);

  setwind(1);
    _pcolor = 1;
    title("\216S&P 500 (USD)");
    xy(0,SPTR);

  setwind(2);
    _pcolor = 2;
    title("\216S&P 500 (EUR)");
    xy(0,SPTR_EUR);

  ytics(70,140,10,2);

  setwind(3);
    _pcolor = 3|5;
    title("\216G(t)");
    xy(0,F1~NR_Index);

  setwind(4);
    _pcolor = 4|5;
    title("\216F(t)");
    xy(0,F2~NR_Index);

  endwind;
